import { Knex } from 'knex';
export declare const HEARTBEAT_QUERIES: Readonly<{
    ORACLE: "select 1 from DUAL";
    POSTGRESQL: "SELECT 1";
    MYSQL: "SELECT 1";
    MSSQL: "SELECT 1";
    SQLITE: "SELECT 1";
    DEFAULT: "SELECT 1";
}>;
export interface HeartbeatResult {
    isOk: boolean;
    error?: Error;
}
/**
 *
 * @param {Object} knex - Knex instance
 * @param {string} heartbeatQuery - SQL query that will be executed to check if connection is valid
 * @returns Promise<{Object|undefined}> wrapped error if connection is not valid, wrapped 'isOk: true' if it is valid, undefined if connection does not yet exist
 */
export declare function checkHeartbeat(knex: Knex, heartbeatQuery?: string): Promise<HeartbeatResult>;
